(******************************************************************)
(*                                3455                            *)
(******************************************************************)
MODULE AVi3455;

FROM FIO     IMPORT  Open,Create,AssignBuffer,Rename,Size,directory,
                     RdBin,WrBin,ReadFirstEntry,ReadNextEntry,
                     PathTail,FileAttr,DirEntry,EOF,IOcheck,File,
                     directory,Seek,Close,Erase,IOcheck,Truncate;
FROM SYSTEM  IMPORT  Registers,Seg,Ofs,DI,EI;
FROM Lib     IMPORT  Dos,ParamCount,ParamStr,DisableBreakCheck;
FROM Str     IMPORT  Copy,Append,Pos,Length,Caps;
FROM IO      IMPORT  RdKey,WrStr,WrLn,WrCard,WrChar,
                     WrShtHex,WrLngHex,WrHex,WrLngCard;
FROM Storage IMPORT  ALLOCATE,DEALLOCATE;
FROM Trace   IMPORT  Trace21,Trace13;
FROM DK13    IMPORT  OK13,Int13;

CONST VirLen=LONGCARD(3455);

VAR
    TotalInfected:CARDINAL; (* 稪 ࠦ                *)
    TotalChecked:CARDINAL; (* 稪 ஢७                *)
    TotalCured:CARDINAL; (* 稪 뫥祭                   *)
    NeedCure  : BOOLEAN; (* ਧ 室 祭        *)
    Parameter,Parameter1 : ARRAY [0..127] OF CHAR; (* ࠬ  *)
    InMem:BOOLEAN; (* ਧ                *)
    Cleared:BOOLEAN; (* ਧ ⪨                     *)
    EXEHead:RECORD  (*  -䠩 *)
       CASE : BOOLEAN OF
        | TRUE :
             MZ,PartPag,PageCnt,ReloCnt,HdrSize,MinMem,MaxMem,
             ReloSS,ExeSP,ChkSum,ExeIP,ReloCS,TablOff,Ovrl:CARDINAL;
        | FALSE :
             JMP :SHORTCARD;Relo:CARDINAL;
             Bt:ARRAY [0..24] OF SHORTCARD;
        END
      END;
    TDA : RECORD  (* , ६, ਡ 䠩                  *)
           FDate : CARDINAL;
           FTime : CARDINAL;
           FAttr : CARDINAL;
          END;
    R : Registers;Ch:CHAR;Index:CARDINAL;
    Buf : ARRAY [0..511] OF SHORTCARD; (*  ᪠ *)
    Vec21[0:21H*4],Old21,
    Vec13[0:13H*4],Old13:RECORD O,S:CARDINAL END;

(*****************************************************************)
(*         楤 ࠭ ६, , ਡ          *)
(*****************************************************************)
PROCEDURE SaveTDA(FileName:ARRAY OF CHAR);
VAR H:CARDINAL;
BEGIN
 R.AX:=4300H;R.DS:=Seg(FileName);R.DX:=Ofs(FileName);Dos(R);TDA.FAttr:=R.CX;
 R.AX:=3D00H;R.DS:=Seg(FileName);R.DX:=Ofs(FileName);Dos(R);H:=R.AX;
 R.AX:=5700H;R.BX:=H;Dos(R);TDA.FDate:=R.DX;TDA.FTime:=R.CX;
 R.AH:=3EH;R.BX:=H;Dos(R);
END SaveTDA;

(*****************************************************************)
(*    楤 ⠭  ६,  , ਡ         *)
(*****************************************************************)
PROCEDURE RestTDA(FileName:ARRAY OF CHAR);
VAR H:CARDINAL;
BEGIN
 R.AX:=4301H;R.DS:=Seg(FileName);R.DX:=Ofs(FileName);R.CX:=TDA.FAttr;Dos(R);
 R.AX:=3D00H;R.DS:=Seg(FileName);R.DX:=Ofs(FileName);Dos(R);H:=R.AX;
 R.AX:=5701H;R.BX:=H;R.DX:=TDA.FDate;R.CX:=TDA.FTime;Dos(R);
 R.AH:=3EH;R.BX:=H;Dos(R);
END RestTDA;

(*****************************************************************)
(*           楤 ஢ન 室 祭            *)
(*****************************************************************)
PROCEDURE Infected(FileName:ARRAY OF CHAR):BOOLEAN;
VAR
 F:File;Ridden:CARDINAL;i:CARDINAL;
 FilePos:LONGCARD;Buf : ARRAY [0..15] OF SHORTCARD;
BEGIN
 INC(TotalChecked);
 SaveTDA(FileName);

 (*  ਡ *)
 R.AX:=4301H;R.DS:=Seg(FileName);R.DX:=Ofs(FileName);
 R.CX:=0;Dos(R);
 F:=Open(FileName);

 IF Size(F)<(24+3455) THEN Close(F);RestTDA(FileName);RETURN(FALSE) END;
 Ridden:=RdBin(F,EXEHead,SIZE(EXEHead));
 IF (EXEHead.MZ=4D5AH)OR(EXEHead.MZ=5A4DH)
  THEN (* EXE-䠩 *)
   FilePos:=LONGCARD(EXEHead.HdrSize+EXEHead.ReloCS)*16+LONGCARD(EXEHead.ExeIP)
  ELSE (* COM-䠩 *)
   IF (EXEHead.JMP#0E9H) THEN Close(F);RETURN(FALSE) END;
   FilePos:=LONGCARD(EXEHead.Relo+3);
  END;
  Seek(F,FilePos);
  Ridden:=RdBin(F,Buf,16);
  Close(F);RestTDA(FileName);
  i:=0;
  WHILE ((Buf[i]=0F9H)OR(Buf[i]=02EH)OR(Buf[i]=0FCH)OR(Buf[i]=0F8H)OR
        (Buf[i]=036H)OR(Buf[i]=03EH)OR(Buf[i]=0FDH)OR(Buf[i]=090H)OR
        (Buf[i]=0F5H)OR(Buf[i]=0FBH))&(i#15) DO INC(i) END;
  IF (Buf[i]#50H)OR(i=15) THEN RETURN FALSE END;INC(i);
  WHILE ((Buf[i]=0F9H)OR(Buf[i]=02EH)OR(Buf[i]=0FCH)OR(Buf[i]=0F8H)OR
        (Buf[i]=036H)OR(Buf[i]=03EH)OR(Buf[i]=0FDH)OR(Buf[i]=090H)OR
        (Buf[i]=0F5H)OR(Buf[i]=0FBH))&(i#15) DO INC(i) END;
  IF (Buf[i]#0E9H)OR(i=15) THEN RETURN FALSE END;
  INC(TotalInfected);WrStr('- '+7C);
  RETURN TRUE;
END Infected;

(*****************************************************************)
(*        楤 祭 쭮  䠩                      *)
(*****************************************************************)
PROCEDURE Cure(FileName:ARRAY OF CHAR);

VAR
 Skip,XSeed,XAdd:
        RECORD
        CASE : BOOLEAN  OF
          | TRUE : CA:CARDINAL;
          | FALSE: SC:ARRAY [0..1] OF SHORTCARD;
        END
       END;
 i,j,k,Ridden,OO,SS : CARDINAL;
 Buf : ARRAY [0..15] OF SHORTCARD;
 F:File;
 FilePos,BasePos,OldLen,FiLen:LONGCARD;
 (* 砫   *)
 Virus : RECORD
          Empty1 : ARRAY [0..15] OF SHORTCARD;
          OldBeg : ARRAY [16..18] OF SHORTCARD;
          Empty2 : ARRAY [19..29] OF SHORTCARD;
          OldSS,OldSP : CARDINAL;
          Empty3 : ARRAY [34..35] OF SHORTCARD;
          OldIP,OldCS : CARDINAL;
          Empty4 : ARRAY [40..41] OF SHORTCARD;
          Ads    : ARRAY [1..10] OF CARDINAL;
          Empty5 : ARRAY [62..63] OF SHORTCARD;
          Parts  : ARRAY [1..10] OF ARRAY [1..10] OF SHORTCARD;
          Empty6 : CARDINAL;
         END;

PROCEDURE NextPos; (* ᫥ 室 *)
BEGIN
 Seek(F,FilePos);Ridden:=RdBin(F,Buf,16);
 i:=0;
 WHILE (Buf[i]#0E9H)&(Buf[i]#0EBH)&(i<15) DO INC(i) END;
 IF Buf[i]=0E9H
  THEN (* ᥣ  *)
   Skip.CA:=0;Skip.SC[0]:=Buf[i+1];Skip.SC[1]:=Buf[i+2];
   INC(FilePos,LONGCARD(i)+3);
   IF INTEGER(Skip.CA)>0
    THEN INC(FilePos,LONGCARD(Skip.CA));
    ELSE DEC(FilePos,LONGCARD(-INTEGER(Skip.CA)))
   END;
  ELSE (* ᥣ ⪨ *)
   INC(FilePos,LONGCARD(i)+2);
   IF SHORTINT(Buf[i+1])>0
    THEN INC(FilePos,LONGCARD(Buf[i+1]))
    ELSE DEC(FilePos,LONGCARD(-SHORTINT(Buf[i+1])))
   END
  END
END NextPos;

BEGIN
 IF NeedCure
  THEN

   SaveTDA(FileName);

   (*  ਡ *)
   R.AX:=4301H;R.DS:=Seg(FileName);R.DX:=Ofs(FileName);
   R.CX:=0;Dos(R);

   F:=Open(FileName);FiLen:=Size(F);

   Ridden:=RdBin(F,EXEHead,SIZE(EXEHead));
   IF (EXEHead.MZ=4D5AH)OR(EXEHead.MZ=5A4DH)
    THEN (* EXE-䠩 *)
     FilePos:=LONGCARD(EXEHead.HdrSize+EXEHead.ReloCS)*16+LONGCARD(EXEHead.ExeIP)
    ELSE (* COM-䠩 *)
     FilePos:=LONGCARD(EXEHead.Relo+3);
   END;

   FOR j:=1 TO 5 DO NextPos() END;
   k:=0;
   WHILE ((Buf[k]=0F9H)OR(Buf[k]=02EH)OR(Buf[k]=0FCH)OR(Buf[k]=0F8H)OR
         (Buf[k]=036H)OR(Buf[k]=03EH)OR(Buf[k]=0FDH)OR(Buf[k]=090H)OR
         (Buf[k]=0F5H)OR(Buf[k]=0FBH))&(k#15) DO INC(k) END;
         XSeed.SC[0]:=Buf[k+1];XSeed.SC[1]:=Buf[k+2];

   FOR j:=1 TO 2 DO NextPos() END;
   k:=0;
   WHILE ((Buf[k]=0F9H)OR(Buf[k]=02EH)OR(Buf[k]=0FCH)OR(Buf[k]=0F8H)OR
         (Buf[k]=036H)OR(Buf[k]=03EH)OR(Buf[k]=0FDH)OR(Buf[k]=090H)OR
         (Buf[k]=0F5H)OR(Buf[k]=0FBH))&(k#15) DO INC(k) END;
         XAdd.SC[0]:=Buf[k+2];XAdd.SC[1]:=Buf[k+3];

   Seek(F,FiLen-VirLen);
   Ridden:=RdBin(F,Virus,SIZE(Virus));
   OO:=Ofs(Virus);SS:=Seg(Virus);
   FOR k:=0 TO SIZE(Virus)-2 DO  (*  ஢ *)
    [SS:OO]^:=CARDINAL(BITSET([SS:OO]^)/BITSET(XSeed.CA));
    XSeed.CA:=XSeed.CA+XAdd.CA;INC(OO);
   END;

   IF (EXEHead.MZ=4D5AH)OR(EXEHead.MZ=5A4DH)
    THEN (* EXE-䠩 *)
     BasePos:=LONGCARD(EXEHead.HdrSize+EXEHead.ReloCS)*16;
     FOR k:=1 TO 10 DO
      Seek(F,LONGCARD(Virus.Ads[k])+BasePos);
      WrBin(F,Virus.Parts[k][1],10);
     END;
     EXEHead.ReloCS:=Virus.OldCS;
     EXEHead.ExeIP:=Virus.OldIP;
     EXEHead.ReloSS:=Virus.OldSS;
     EXEHead.ExeSP:=Virus.OldSP;
     OldLen:=FiLen-VirLen;
     EXEHead.PartPag:=CARDINAL(OldLen MOD 512);
     EXEHead.PageCnt:=CARDINAL(OldLen DIV 512);
     IF EXEHead.PartPag#0 THEN INC(EXEHead.PageCnt) END;
     Seek(F,0);WrBin(F,EXEHead,SIZE(EXEHead));
    ELSE (* COM-䠩 *)
     FOR k:=1 TO 10 DO
      Seek(F,LONGCARD(Virus.Ads[k]-100H));
      WrBin(F,Virus.Parts[k][1],10);
     END;
     Seek(F,0);WrBin(F,Virus.OldBeg,3);
   END;
   Seek(F,OldLen);Truncate(F);
   Close(F);

   RestTDA(FileName);
   INC(TotalCured);
   WrStr('  ');
 END
END Cure;

(*****************************************************************)
(*      楤 ४ᨢ 室 ॢ ⠫           *)
(*****************************************************************)
PROCEDURE GoAroundTree(Path:ARRAY OF CHAR);
VAR
 IsEntry:BOOLEAN;
 FoundEntry:DirEntry;
 PathCopy1,PathCopy2:ARRAY [0..127] OF CHAR;

  (*  뫮    ᥡ *)
  PROCEDURE DummyPointer(DirName:ARRAY OF CHAR):BOOLEAN;
  BEGIN RETURN Pos(DirName,'.')#MAX(CARDINAL) END DummyPointer;

BEGIN

 (*  ⠫  ⠫ *)
 Copy(PathCopy1,Path);
 Append(PathCopy1,'\*.*');
 IsEntry:=ReadFirstEntry(PathCopy1,FileAttr{directory},FoundEntry);
 WHILE IsEntry DO
  IF (~DummyPointer(FoundEntry.Name))&
     ( directory IN FoundEntry.attr ) (* 室   訡  FIO *)
   THEN
    Copy(PathCopy2,Path);
    Append(PathCopy2,'\');
    Append(PathCopy2,FoundEntry.Name);
    GoAroundTree(PathCopy2);
  END;
  IsEntry:=ReadNextEntry(FoundEntry);
 END;

 (*  ⮬  ⠫  - 饬 楫  祭     *)
 Copy(PathCopy1,Path);
 Append(PathCopy1,'\*.EXE');
 IsEntry:=ReadFirstEntry(PathCopy1,FileAttr{},FoundEntry);
 WHILE IsEntry DO
  Copy(PathCopy2,Path);
  Append(PathCopy2,'\');
  Append(PathCopy2,FoundEntry.Name);
  WrStr('                                                         ');
  WrStr(15C);
  WrStr(PathCopy2);
  IF Infected(PathCopy2) THEN Cure(PathCopy2);WrLn  END;
  WrStr(15C);
  IsEntry:=ReadNextEntry(FoundEntry);
 END;
 Copy(PathCopy1,Path);
 Append(PathCopy1,'\*.COM');
 IsEntry:=ReadFirstEntry(PathCopy1,FileAttr{},FoundEntry);
 WHILE IsEntry DO
  Copy(PathCopy2,Path);
  Append(PathCopy2,'\');
  Append(PathCopy2,FoundEntry.Name);
  WrStr('                                                         ');
  WrStr(15C);
  WrStr(PathCopy2);
  IF Infected(PathCopy2) THEN Cure(PathCopy2);WrLn  END;
  WrStr(15C);
  IsEntry:=ReadNextEntry(FoundEntry);
 END;
END GoAroundTree;

(*****************************************************************)
(*      楤 ᪠   㭨⮦        *)
(*****************************************************************)
PROCEDURE SearchMem;
BEGIN
 R.AX:=4B53H;Dos(R);
 InMem:=(R.AX=454BH)&(R.BX#1234H);
END SearchMem;

(*****************************************************************)
(*   楤 ᪠   㭨⮦  MBR  BOOT         *)
(*****************************************************************)
PROCEDURE SearchDK(DrT:ARRAY OF CHAR);
VAR Drive:CARDINAL;Q:CARDINAL;i:CARDINAL;

PROCEDURE Err13();
BEGIN
  IF ~OK13 THEN WrStr(7C+15C+12C+'   ');HALT END;
END Err13;

BEGIN
 Caps(DrT);
 IF Pos(DrT,'A:')#0FFFFH THEN Drive:=0
 ELSIF Pos(DrT,'B:')#0FFFFH THEN Drive:=1
 ELSE Drive:=80H
 END;
 Q:=Int13(2,Drive,0,0,1,1,Buf);Err13;
 IF (Buf[0]=33H)&(Buf[1]=0DBH)&(Buf[2]=0FAH)&
    (Buf[21H]=06H)
     THEN WrStr(15C+12C+7C+'    ');
  IF NeedCure
   THEN
    i:=2;
    LOOP
     Q:=Int13(2,Drive,0,0,i,1,Buf);
     IF ~OK13 THEN EXIT END; (* 室   ४ *)
     IF (Buf[0]=0FAH)&(Buf[1]=033H)&(Buf[2]=0C0H)&(Buf[21H]=04H)
      THEN (*  ਣ MBR *)
       Q:=Int13(3,Drive,0,0,1,1,Buf);
       Err13;WrStr(' -  !');Cleared:=TRUE;EXIT
     END;
     INC(i);
    END;
    IF ~OK13 THEN WrStr(' -   .  . ') END;
   END
  END
END SearchDK;

BEGIN
 DisableBreakCheck();
 SearchMem();
 Old21:=Vec21;Old13:=Vec13;
 Trace21(Vec21.S,Vec21.O);
 Trace13(Vec13.S,Vec13.O);
 WrLn;
 WrStr('------------------------------------------------');WrLn;
 WrStr('     ணࠬ-  䠩, ࠦ    ');WrLn;
 WrStr('              ᮬ     3455                  ');WrLn;
 IF ParamCount()=0
  THEN
   WrStr('         (c) KostyaSoft, 1995             ');WrLn;
   WrStr('      : AVI3455    < ய > [-]      ');WrLn;
   WrStr('   c  t 砥 室 㤠  ');WrLn;
   WrStr('  ࠦ 䠩  ⪨ 祭 ᪠     ');WrLn;
   WrStr('------------------------------------------------');WrLn;
  ELSE
   WrStr('------------------------------------------------');WrLn;
   WrLn;
   ParamStr(Parameter,1);
   Caps(Parameter);
   NeedCure:=FALSE;
   IF (ParamCount()>1)
    THEN
     ParamStr(Parameter1,2);
     Caps(Parameter1);
     NeedCure:=(Pos(Parameter1,'-C')#MAX(CARDINAL))OR
               (Pos(Parameter1,'-T')#MAX(CARDINAL))OR
               (Pos(Parameter1,'/C')#MAX(CARDINAL))OR
               (Pos(Parameter1,'/T')#MAX(CARDINAL));
     IF ~NeedCure THEN WrStr('  ᯮ !');WrLn;WrLn END;
   END;
   TotalInfected:=0;TotalChecked:=0;TotalCured:=0;
   IF InMem
    THEN WrStr(7C+'   !    !'+15C+12C);
   END;
   Cleared:=FALSE;SearchDK(Parameter);
   GoAroundTree(Parameter);
   WrLn;WrLn;
   WrStr('ᥣ ஢७        : ');WrCard(TotalChecked,5);WrLn;
   WrStr('㦥 ࠦ  : ');WrCard(TotalInfected,5);WrLn;
   WrStr('ம஢         : ');WrCard(TotalCured,5);
  END;
  WrLn;
  Vec13:=Old13;Vec21:=Old21;
END AVi3455.
